﻿' -----------------------------------------------------------------------------------------
'
' FTS08.vb                                                          Ulrich Müller  25.02.08
'                                                                   PCS1700 VB 2005 Express
' Mobile Robots II : Fahrerloses Transportsystem, Steurung der Einzelschritte über Funk
'              Basis ist die Assembly FishFace2005.DLL
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFace40

Public Class FTS08

  Dim ft As New FishFace()

  Const mRechts As Out = Out.M1
  Const mLinks As Out = Out.M2
  Const iImpulseR As Inp = Inp.I1
  Const iImpulseL As Inp = Inp.I2
  Const dVor As Dir = Dir.Links
  Const dRuck As Dir = Dir.Rechts

  Const iRechtsRaus As Inp = Inp.I3
  Const iLinksRaus As Inp = Inp.I4

  Const mHupe As Out = Out.M3

  Const mHub As Out = Out.M4
  Const iHubOben As Inp = Inp.I5
  Const iHubUnten As Inp = Inp.I6
  Const dAb As Dir = Dir.Links
  Const dAuf As Dir = Dir.Rechts

#Region "--- ProgramControl ---"
  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
  Handles cmdAction.Click
    ' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
    '     während des Ablaufs von Action gesperrt
    Try
      If cboPortName.SelectedIndex = 0 Then
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Else
        ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5)
      End If
      cmdAction.Enabled = False
      cmdEnde.Text = "&ENDE"
      lblStatus.Text = "--- Bei der Arbeit ---"
      ft.ClearMotors()
      pnlCommands.Enabled = True
    Catch ex As FishFaceException
      MsgBox(ex.Message)
      ft.CloseInterface()
    End Try

  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    Me.Close()
  End Sub

  Private Sub ManBeispiele_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' --- Default erstes ROBO Interface an USB ---
    cboPortName.SelectedIndex = 0
  End Sub
#End Region

  Private Sub Heben()
    ft.SetMotor(mHub, dAuf)
    ft.WaitForInput(iHubOben)
    ft.SetMotor(mHub, Dir.Aus)
  End Sub
  Private Sub Senken()
    ft.SetMotor(mHub, dAb)
    ft.WaitForInput(iHubUnten)
    ft.SetMotor(mHub, Dir.Aus)
  End Sub
  Private Sub Rueck(ByVal Schritte As Integer)
    ft.SetMotor(mRechts, dRuck, Speed.Half)
    ft.SetMotor(mLinks, dRuck, Speed.Half)
    ft.WaitForChange(iImpulseR, Schritte)
    ft.SetMotor(mRechts, Dir.Aus)
    ft.SetMotor(mLinks, Dir.Aus)
  End Sub
  Private Sub Vor(ByVal Schritte As Integer)
    ft.SetMotor(mRechts, dVor, Speed.Half)
    ft.SetMotor(mLinks, dVor, Speed.Half)
    ft.WaitForChange(iImpulseR, Schritte)
    ft.SetMotor(mRechts, Dir.Aus)
    ft.SetMotor(mLinks, Dir.Aus)
  End Sub
  Private Sub Hupen(ByVal nrHupen As Integer)
    For i As Integer = 1 To nrHupen
      ft.SetMotor(mHupe, Dir.Ein)
      ft.Pause(333)
      ft.SetMotor(mHupe, Dir.Aus)
      ft.Pause(222)
    Next
  End Sub
  Private Sub SpurFahren()
    Do
      ft.SetMotor(mRechts, dVor, Speed.Half)
      ft.SetMotor(mLinks, dVor, Speed.Half)
      If ft.GetInput(iRechtsRaus) Then
        ft.SetMotor(mLinks, dRuck, Speed.Half)
      ElseIf ft.GetInput(iLinksRaus) Then
        ft.SetMotor(mRechts, dRuck, Speed.Half)
      End If
      ft.Pause(12)
    Loop While (ft.GetInputs() And &HC) <> &HC And Not ft.Finish()
    ft.SetMotor(mRechts, Dir.Aus)
    ft.SetMotor(mLinks, Dir.Aus)
    Hupen(2)
  End Sub
  Private Sub Drehen()
    ft.SetMotor(mRechts, dVor, Speed.Half)
    ft.SetMotor(mLinks, dRuck, Speed.Half)
    Do
      Application.DoEvents()
      ft.Pause(12)
    Loop While (ft.GetInputs() And &HC) = &HC And Not ft.Finish()
    ft.SetMotor(mRechts, Dir.Aus)
    ft.SetMotor(mLinks, Dir.Aus)
  End Sub
  Private Sub Abladen()
    Vor(8)
    Senken()
    Rueck(7)
  End Sub
  Private Sub Aufladen()
    Vor(8)
    Heben()
    Rueck(7)
  End Sub

  Private Sub cmdSpur_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSpur.Click
    lblStatus.Text = "SpurFahren"
    SpurFahren()
    lblStatus.Text = "Bereit für neue Befehle"
  End Sub

  Private Sub cmdAbladen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAbladen.Click
    lblStatus.Text = "Abladen"
    Abladen()
    lblStatus.Text = "Bereit für neue Befehle"
  End Sub

  Private Sub cmdAufladen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAufladen.Click
    lblStatus.Text = "Aufladen"
    Aufladen()
    lblStatus.Text = "Bereit für neue Befehle"
  End Sub

  Private Sub cmdDrehen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDrehen.Click
    lblStatus.Text = "Drehen"
    Drehen()
    lblStatus.Text = "Bereit für neue Befehle"
  End Sub

  Private Sub cmdHolen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdHolen.Click
    lblStatus.Text = "Senken"
    Senken()
    lblStatus.Text = "SpurFahren"
    SpurFahren()
    lblStatus.Text = "Aufladen"
    Aufladen()
    lblStatus.Text = "Drehen"
    Drehen()
    lblStatus.Text = "SpurFahren"
    SpurFahren()
    lblStatus.Text = "Abladen"
    Abladen()
    lblStatus.Text = "Bereit für neue Befehle"
  End Sub

  Private Sub cmdBringen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdBringen.Click
    lblStatus.Text = "AnFahren"
    SpurFahren()
    lblStatus.Text = "Aufladen"
    Aufladen()
    lblStatus.Text = "Drehen"
    Drehen()
    lblStatus.Text = "SpurFahren"
    SpurFahren()
    lblStatus.Text = "Abladen"
    Abladen()
    lblStatus.Text = "Drehen"
    Drehen()
    lblStatus.Text = "SpurFahren"
    SpurFahren()
    lblStatus.Text = "Bereit für neue Befehle"
  End Sub
End Class
